/* Sistemas Integrados TECNISA

Nome: 0148_GERTRG_DTULTATU_TAREFA.SQL

Descrio:

Atualiza a data de ultima atualizao da tabela TAREFA

Criao:
09/09/2003 Alexis Tolentino
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TAREFA' and
            type = 'TR'                  and
            u.uid = o.uid                and
            u.name = USER)
  DROP TRIGGER DTULTATU_TAREFA
  GO

CREATE TRIGGER DTULTATU_TAREFA
ON TAREFA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TAREFA', 'NRTAREFA=' + NRTAREFA +
                                 ';CDFILIAL=' + CDFILIAL+';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE TAREFA
      SET  DTULTATUTARE = GETDATE()
      FROM INSERTED
      WHERE
        ISNULL(TAREFA.NRTAREFA,0) = ISNULL(INSERTED.NRTAREFA,0) AND
        ISNULL(TAREFA.CDFILIAL,0) = ISNULL(INSERTED.CDFILIAL,0);
   END;
END;
GO

